# PRTG Custom Whois Monitoring Script

Dieses Skript ermöglicht es, Domains in **PRTG** zu überwachen. Es nutzt `whois.exe`, um den Status einer Domain zu überprüfen und optional das **Erstellungsdatum (Created)** sowie das **letzte Aktualisierungsdatum (Updated)** auszugeben.

## 📌 Funktionen
✅ **Überwachung von Domains in PRTG** (Status: registriert/frei)  
✅ **Erkennt das "Creation Date" und "Updated Date"** für `.com`, `.net`, `.org` uvm.  
✅ **PRTG-kompatible JSON-Ausgabe** für einfache Integration  
✅ **Fehlermeldungen und Debugging über Log-Dateien**  


## 🛠 Einrichtung in PRTG

### 1️⃣ Skript speichern
Speichere die Datei als **`CustomWhoisCheck.ps1`** unter:
```plaintext
C:\Program Files (x86)\PRTG Network Monitor\Custom Sensors\EXEXML\
```

### 2️⃣ whois.exe installieren
Lade whois.exe von Microsoft Sysinternals herunter und speichere sie z. B. in:
```plaintext
C:\Apps\WhoIs\whois.exe
```

🔗 [Download: Whois von Sysinternals](https://docs.microsoft.com/en-us/sysinternals/downloads/whois)


## 🔧 Nutzung in PRTG

### 1️⃣ Neuen Sensor in PRTG erstellen
1. Neuen Sensor hinzufügen
2. Sensor-Typ: `EXE/Script Advanced`
3. Skript auswählen: `CustomWhoisCheck.ps1`
4. Parameter hinzufügen:

   ```plaintext
   -Domain "techniverse.net"
   ```
5. Sensor speichern & testen

### 2️⃣ Alternative: Domain als PRTG-Parameter setzen

Falls du Domains direkt über das Gerät in PRTG definieren möchtest:
```plaintext
-Domain "%host"
```


## 🚦 Wann wird der Sensor rot?

### 🔴 Sensor wird rot, wenn:
- Die Domain frei ist → Gefahr von Domaingrabbing!
- `whois.exe` keine Antwort liefert (z. B. Netzwerkproblem)
- Der Whois-Server nicht erreichbar ist

### 🟢 Sensor bleibt grün, wenn:
- Die Domain registriert ist
- Whois-Abfrage erfolgreich war

📌 `.de`-Domains zeigen nur "registriert", da DENIC keine Creation/Updated-Daten über Whois bereitstellt.


## 🔴 1️⃣ PRTG so einstellen, dass der Sensor auf "Fehler" geht (rot)

Standardmäßig zeigt PRTG den Sensor als "OK" an, auch wenn der Wert 2 ist. Damit PRTG dies als Fehler erkennt, müssen wir eine Einstellung anpassen:

1. Gehe in PRTG zu deinem Sensor
2. Klicke auf "Kanäle"
3. Wähle den Kanal "Domain Status" aus
4. Scrolle nach unten zu "Erweiterte Kanal-Einstellungen"
5. Setze bei "Fehler, wenn Wert größer als" den Wert auf 1
6. Speichern & testen

📌 **Ergebnis:**
- **0 = OK (🟢 grün)** → Domain ist registriert  
- **2 = Fehler (🔴 rot)** → Domain ist frei und kann registriert werden!

Jetzt sollte der Sensor auf rot springen, wenn die Domain frei wird. ✅


---
**Autor:** Patrick Asmus  
**Lizenz:** MIT